=== added directory 'msf_instance'
=== added file 'msf_instance/__init__.py'
--- msf_instance/__init__.py	1970-01-01 00:00:00 +0000
+++ msf_instance/__init__.py	2012-06-04 07:08:04 +0000
@@ -0,0 +1,25 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2011 MSF, TeMPO Consulting.
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+import msf_instance
+import res_company
+import add_instance
+
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added file 'msf_instance/__openerp__.py'
--- msf_instance/__openerp__.py	1970-01-01 00:00:00 +0000
+++ msf_instance/__openerp__.py	2012-06-04 07:08:04 +0000
@@ -0,0 +1,41 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2011 MSF, TeMPO Consulting.
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+{
+    "name" : "MSF Proprietary Instance",
+    "version": "1.1",
+    "author" : "MSF, TeMPO Consulting",
+    "developer": "Matthieu Dietrich",
+    "category" : "Generic Modules/Projects & Services",
+    "depends" : ["account_msf", "res_currency_functional"],
+    "description": """Module for defining proprietary instances, their informations
+    """,
+    "init_xml" : [],
+    "update_xml": [
+        'msf_instance_view.xml',
+        'data/instance_data.xml',
+    ],
+    'demo_xml': [
+    ],
+    'installable': True,
+    'active': False,
+#    'certificate': 'certificate',
+}
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added file 'msf_instance/add_instance.py'
--- msf_instance/add_instance.py	1970-01-01 00:00:00 +0000
+++ msf_instance/add_instance.py	2012-06-04 07:08:04 +0000
@@ -0,0 +1,115 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2011 MSF, TeMPO Consulting.
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+from osv import fields, osv
+
+class account_analytic_journal(osv.osv):
+    _name = 'account.analytic.journal'
+    _inherit = 'account.analytic.journal'
+    
+    _columns = {
+        'instance_id': fields.many2one('msf.instance', 'Proprietary Instance'),
+    }
+    
+    _defaults = {
+        'instance_id': lambda self, cr, uid, c: self.pool.get('res.users').browse(cr, uid, uid, c).company_id.instance_id.id,
+    }
+
+account_analytic_journal()
+
+class account_analytic_line(osv.osv):
+    _name = 'account.analytic.line'
+    _inherit = 'account.analytic.line'
+    
+    _columns = {
+        'instance_id': fields.related('journal_id',
+                                      'instance_id',
+                                      string='Proprietary Instance',
+                                      store={'account.analytic.journal': (lambda self, cr, uid, ids, c=None: ids, ['instance_id'], 10)},
+                                      readonly=True,
+                                      type="many2one",
+                                      relation="msf.instance"),
+    }
+
+account_analytic_line()
+
+class account_journal(osv.osv):
+    _name = 'account.journal'
+    _inherit = 'account.journal'
+    
+    _columns = {
+        'instance_id': fields.many2one('msf.instance', 'Proprietary Instance'),
+    }
+    
+    _defaults = {
+        'instance_id': lambda self, cr, uid, c: self.pool.get('res.users').browse(cr, uid, uid, c).company_id.instance_id.id,
+    }
+
+account_journal()
+
+class account_move(osv.osv):
+    _name = 'account.move'
+    _inherit = 'account.move'
+    
+    _columns = {
+        'instance_id': fields.related('journal_id',
+                                      'instance_id',
+                                      string='Proprietary Instance',
+                                      store={'account.journal': (lambda self, cr, uid, ids, c=None: ids, ['instance_id'], 10)},
+                                      readonly=True,
+                                      type="many2one",
+                                      relation="msf.instance"),
+    }
+
+account_move()
+
+class account_move_line(osv.osv):
+    _name = 'account.move.line'
+    _inherit = 'account.move.line'
+    
+    _columns = {
+        'instance_id': fields.related('journal_id',
+                                      'instance_id',
+                                      string='Proprietary Instance',
+                                      store={'account.journal': (lambda self, cr, uid, ids, c=None: ids, ['instance_id'], 10)},
+                                      readonly=True,
+                                      type="many2one",
+                                      relation="msf.instance"),
+    }
+
+account_move_line()
+
+class account_bank_statement(osv.osv):
+    _name = 'account.bank.statement'
+    _inherit = 'account.bank.statement'
+    
+    _columns = {
+        'instance_id': fields.related('journal_id',
+                                      'instance_id',
+                                      string='Proprietary Instance',
+                                      store={'account.journal': (lambda self, cr, uid, ids, c=None: ids, ['instance_id'], 10)},
+                                      readonly=True,
+                                      type="many2one",
+                                      relation="msf.instance"),
+    }
+
+account_bank_statement()
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added directory 'msf_instance/data'
=== added file 'msf_instance/data/instance_data.xml'
--- msf_instance/data/instance_data.xml	1970-01-01 00:00:00 +0000
+++ msf_instance/data/instance_data.xml	2012-06-04 07:08:04 +0000
@@ -0,0 +1,13 @@
+<openerp>
+    <data>
+        
+        <!-- Parent Instance -->
+        <record model="msf.instance" id="instance_section">
+            <field name="code">OCG</field>
+            <field name="name">Geneva</field>
+            <field name="level">section</field>
+            <field name="cost_center_id" ref="analytic_distribution.analytic_account_project"/>
+        </record>
+        
+    </data>
+</openerp>

=== added file 'msf_instance/msf_instance.py'
--- msf_instance/msf_instance.py	1970-01-01 00:00:00 +0000
+++ msf_instance/msf_instance.py	2012-06-04 07:08:04 +0000
@@ -0,0 +1,106 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2011 MSF, TeMPO Consulting.
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+from osv import fields, osv
+
+class msf_instance(osv.osv):
+    _name = 'msf.instance'
+    
+    _columns = {
+        'level': fields.selection([('section', 'Section'),
+                                   ('coordo', 'Coordo'),
+                                   ('project', 'Project')], 'Level', required=True),
+        'code': fields.char('Code', size=64, required=True),
+        'mission': fields.char('Mission', size=64),
+        'instance': fields.char('Instance', size=64),
+        'parent_id': fields.many2one('msf.instance', 'Parent', domain=[('level', '!=', 'project'), ('state', '=', 'active')]),
+        'name': fields.char('Name', size=64, required=True),
+        'note': fields.char('Note', size=256),
+        'cost_center_id': fields.many2one('account.analytic.account', 'Cost Center', domain=[('category', '=', 'OC')], required=True),
+        'state': fields.selection([('draft', 'Draft'),
+                                   ('active', 'Active'),
+                                   ('inactive', 'Inactive')], 'State', required=True),
+    }
+    
+    _defaults = {
+        'state': 'draft',
+    }
+
+    def _check_name_code_unicity(self, cr, uid, ids, context=None):
+        if not context:
+            context = {}
+        for instance in self.browse(cr, uid, ids, context=context):
+            bad_ids = self.search(cr, uid, [('&'),
+                                            ('state', '!=', 'inactive'),
+                                            ('|'),
+                                            ('name', '=ilike', instance.name),
+                                            ('code', '=ilike', instance.code)])
+            if len(bad_ids) and len(bad_ids) > 1:
+                return False
+        return True
+
+    def _check_cost_center_unicity(self, cr, uid, ids, context=None):
+        if not context:
+            context = {}
+        for instance in self.browse(cr, uid, ids, context=context):
+            bad_ids = self.search(cr, uid, [('&'),
+                                            ('state', '!=', 'inactive'),
+                                            ('cost_center_id','=',instance.cost_center_id.id)])
+            if len(bad_ids) and len(bad_ids) > 1:
+                return False
+        return True
+
+    def _check_database_unicity(self, cr, uid, ids, context=None):
+        if not context:
+            context = {}
+        for instance in self.browse(cr, uid, ids, context=context):
+            bad_ids = self.search(cr, uid, [('&'),
+                                            ('state', '!=', 'inactive'),
+                                            ('&'),
+                                            ('instance', '!=', False),
+                                            ('instance', '=', instance.instance)])
+            if len(bad_ids) and len(bad_ids) > 1:
+                return False
+        return True
+
+    _constraints = [
+        (_check_name_code_unicity, 'You cannot have the same code or name than an active instance!', ['code', 'name']),
+        (_check_cost_center_unicity, 'You cannot have the same cost_center than an active instance!', ['cost_center_id']),
+        (_check_database_unicity, 'You cannot have the same database than an active instance!', ['instance']),
+    ]
+    
+    def name_get(self, cr, user, ids, context=None):
+        result = self.browse(cr, user, ids, context=context)
+        res = []
+        for rs in result:
+            txt = rs.code
+            res += [(rs.id, txt)]
+        return res
+    
+    def button_deactivate(self, cr, uid, ids, context=None):
+        """
+        Deactivate instance
+        """
+        self.write(cr, uid, ids, {'state': 'inactive'}, context=context)
+        return True
+    
+msf_instance()
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added file 'msf_instance/msf_instance_view.xml'
--- msf_instance/msf_instance_view.xml	1970-01-01 00:00:00 +0000
+++ msf_instance/msf_instance_view.xml	2012-06-04 07:08:04 +0000
@@ -0,0 +1,273 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<openerp>
+    <data>
+        
+        <record id="view_msf_instance_form" model="ir.ui.view">
+            <field name="name">msf.instance.form</field>
+            <field name="model">msf.instance</field>
+            <field name="type">form</field>
+            <field name="arch" type="xml">
+                <form string="Proprietary Instance" hide_duplicate_button="1" hide_delete_button="1">
+                    <field name="code"/>
+                    <field name="name"/>
+                       <newline/>
+                    <field name="level"/>
+                    <field name="mission" attrs="{'required': [('level', '!=', 'section')], 'readonly': [('level', '=', 'section')]}"/>
+                       <newline/>
+                    <field name="instance" readonly="1"/>
+                    <field name="parent_id" attrs="{'required': [('level', '!=', 'section')], 'readonly': [('level', '=', 'section')]}"/>
+                    <newline/>
+                    <field name="note"/>
+                    <field name="cost_center_id"/>
+                    <newline/>
+                    <field name="state" readonly="1"/>
+                    <button name="button_deactivate" string="Deactivate" type="object"
+                            attrs="{'invisible': [('state', '!=', 'active')]}" icon="terp-check"/>
+                </form>
+            </field>
+        </record>
+        
+        <record id="view_msf_instance_tree" model="ir.ui.view">
+            <field name="name">msf.instance.tree</field>
+            <field name="model">msf.instance</field>
+            <field name="type">tree</field>
+            <field name="arch" type="xml">
+                <tree string="Proprietary Instances" hide_delete_button="1">
+                    <field name="code"/>
+                    <field name="name"/>
+                    <field name="level"/>
+                    <field name="mission"/>
+                    <field name="instance"/>
+                    <field name="parent_id"/>
+                    <field name="cost_center_id"/>
+                    <field name="state"/>
+                </tree>
+            </field>
+        </record>
+        
+        <record id="action_msf_instance_tree" model="ir.actions.act_window">
+            <field name="name">Proprietary Instances</field>
+            <field name="res_model">msf.instance</field>
+            <field name="view_type">form</field>
+            <field name="view_mode">tree,form</field>
+        </record>
+        
+        <menuitem action="action_msf_instance_tree" id="menu_action_msf_instance_tree" parent="base.menu_config"/>
+        
+
+        <record model="ir.ui.view" id="view_company_inherit_4_form">
+            <field name="name">res.company.form.instance.inherit</field>
+            <field name="inherit_id" ref="account_msf.view_company_inherit_3_form"/>
+            <field name="model">res.company</field>
+            <field name="type">form</field>
+            <field name="arch" type="xml">
+                <page string="Configuration" position="inside">
+                  <group col="2" colspan="2">
+                      <separator string="Proprietary Instance" colspan="2"/>
+                      <field name="instance_id" required="1" colspan="2" domain="[('state', '=', 'draft')]"/>
+                  </group>
+                </page>
+            </field>
+        </record>
+
+    <!-- Redefine analytic line tree -->
+        <record id="view_account_analytic_line_instance_tree" model="ir.ui.view">
+            <field name="name">account.analytic.line.instance.tree</field>
+            <field name="model">account.analytic.line</field>
+            <field name="type">tree</field>
+            <field name="inherit_id" ref="account.view_account_analytic_line_tree"/>
+            <field name="arch" type="xml">
+                <field name="journal_id" position="before">
+                    <field name="instance_id"/>
+                </field>
+            </field>
+        </record>
+
+    <!-- Redefine analytic journal -->
+        <record id="view_account_analytic_journal_instance_tree" model="ir.ui.view">
+            <field name="name">account.analytic.journal.instance.tree</field>
+            <field name="model">account.analytic.journal</field>
+            <field name="type">tree</field>
+            <field name="inherit_id" ref="account.view_account_analytic_journal_tree"/>
+            <field name="arch" type="xml">
+                <field name="code" position="before">
+                    <field name="instance_id" readonly="1"/>
+                </field>
+            </field>
+        </record>
+        
+        <record id="view_account_analytic_journal_instance_form" model="ir.ui.view">
+            <field name="name">account.analytic.journal.instance.form</field>
+            <field name="model">account.analytic.journal</field>
+            <field name="type">form</field>
+            <field name="inherit_id" ref="account.view_account_analytic_journal_form"/>
+            <field name="arch" type="xml">
+                <field name="code" position="after">
+                    <field name="instance_id" readonly="1"/>
+                </field>
+            </field>
+        </record>
+        
+    <!-- Redefine G/L journal -->
+        <record id="view_account_journal_form_instance_inherit" model="ir.ui.view">
+            <field name="name">account.journal.form.instance.inherit</field>
+            <field name="model">account.journal</field>
+            <field name="type">form</field>
+            <field name="priority" eval="250" />
+            <field name="inherit_id" ref="account_journal.view_account_journal_form_inherit"/>
+            <field name="arch" type="xml">
+                <separator string="Company" position="after">
+                    <field name="instance_id" readonly="1"/>
+                </separator>
+            </field>
+        </record>
+        
+        <record id="view_account_journal_tree_instance_inherit" model="ir.ui.view">
+            <field name="name">account.journal.tree.instance.inherit</field>
+            <field name="model">account.journal</field>
+            <field name="type">tree</field>
+            <field name="inherit_id" ref="account_journal.view_account_journal_tree_inherit"/>
+            <field name="arch" type="xml">
+                <field name="code" position="before">
+                    <field name="instance_id"/>
+                </field>
+            </field>
+        </record>
+        
+    <!-- Redefine G/L account move -->
+        <record id="view_move_form_instance_inherit" model="ir.ui.view">
+            <field name="name">account.move.form.instance.inherit</field>
+            <field name="model">account.move</field>
+            <field name="type">form</field>
+            <field name="priority" eval="250" />
+            <field name="inherit_id" ref="account.view_move_form"/>
+            <field name="arch" type="xml">
+                <field name="name" position="before">
+                    <field name="instance_id"/>
+                </field>
+            </field>
+        </record>
+        
+        <record id="view_move_tree_instance_inherit" model="ir.ui.view">
+            <field name="name">account.move.tree.instance.inherit</field>
+            <field name="model">account.move</field>
+            <field name="type">tree</field>
+            <field name="inherit_id" ref="account.view_move_tree"/>
+            <field name="arch" type="xml">
+                <field name="name" position="before">
+                    <field name="instance_id"/>
+                </field>
+            </field>
+        </record>
+        
+    <!-- Redefine G/L account move line -->
+        <record id="view_move_line_tree_instance_inherit" model="ir.ui.view">
+            <field name="name">account.move.line.tree.instance.inherit</field>
+            <field name="model">account.move.line</field>
+            <field name="type">tree</field>
+            <field name="inherit_id" ref="res_currency_functional.view_move_line_tree"/>
+            <field name="arch" type="xml">
+                <field name="journal_id" position="before">
+                    <field name="instance_id"/>
+                </field>
+            </field>
+        </record>
+        
+        <record id="view_move_line_tree_editable_instance_inherit" model="ir.ui.view">
+            <field name="name">account.move.line.tree.editable.instance.inherit</field>
+            <field name="model">account.move.line</field>
+            <field name="type">tree</field>
+            <field name="inherit_id" ref="res_currency_functional.view_move_line_tree_editable"/>
+            <field name="arch" type="xml">
+                <field name="journal_id" position="before">
+                    <field name="instance_id"/>
+                </field>
+            </field>
+        </record>
+        
+    <!-- Redefine register -->
+        <record id="inherit_view_bank_statement_instance_form" model="ir.ui.view">
+            <field name='name'>inherit.view.bank.statement.instance.form</field>
+            <field name='model'>account.bank.statement</field>
+            <field name="type">form</field>
+            <field name='inherit_id' ref='register_accounting.inherit_view_bank_statement_form' />
+            <field name="priority" eval="20"/>
+            <field name="arch" type="xml">
+                <data>
+	                <xpath expr="/form//field[@name='journal_id']" position="before">
+	                    <field name="instance_id"/>
+	                </xpath>
+                </data>
+            </field>
+        </record>
+        
+        <record id="inherit_view_bank_statement_instance_form2" model="ir.ui.view">
+            <field name='name'>inherit.view.bank.statement.instance.form2</field>
+            <field name='model'>account.bank.statement</field>
+            <field name="type">form</field>
+            <field name='inherit_id' ref='register_accounting.inherit_view_bank_statement_form2' />
+            <field name="priority" eval="20"/>
+            <field name="arch" type="xml">
+                <data>
+	                <xpath expr="/form//field[@name='journal_id']" position="before">
+	                    <field name="instance_id"/>
+	                </xpath>
+                </data>
+            </field>
+        </record>
+        
+        <record id="view_cheque_register_form" model="ir.ui.view">
+            <field name='name'>view.cheque.register.instance.form</field>
+            <field name='model'>account.bank.statement</field>
+            <field name="type">form</field>
+            <field name='inherit_id' ref='register_accounting.view_cheque_register_form'/>
+            <field name="arch" type="xml">
+                <data>
+                    <xpath expr="/form//field[@name='journal_id']" position="before">
+                        <field name="instance_id"/>
+                    </xpath>
+                </data>
+            </field>
+        </record>
+        
+        <record id="view_bank_statement_instance_tree" model="ir.ui.view">
+            <field name="name">account.bank.statement.instance.tree</field>
+            <field name="model">account.bank.statement</field>
+            <field name="type">tree</field>
+            <field name="priority" eval="16"/>
+            <field name='inherit_id' ref='account.view_bank_statement_tree' />
+            <field name="arch" type="xml">
+                <xpath expr="/tree/field[@name='name']" position="before">
+                    <field name="instance_id"/>
+                </xpath>
+            </field>
+        </record>
+        
+        <record id="view_cash_statement_instance_tree" model="ir.ui.view">
+            <field name="name">account.cash.statement.instance.tree</field>
+            <field name="model">account.bank.statement</field>
+            <field name="type">tree</field>
+            <field name="priority" eval="16"/>
+            <field name='inherit_id' ref='register_accounting.view_cash_statement_tree' />
+            <field name="arch" type="xml">
+                <xpath expr="/tree/field[@name='name']" position="before">
+                    <field name="instance_id"/>
+                </xpath>
+            </field>
+        </record>
+        
+        <record id="view_cheque_register_instance_tree" model="ir.ui.view">
+            <field name="name">account.cheque.register.instance.tree</field>
+            <field name="model">account.bank.statement</field>
+            <field name="type">tree</field>
+            <field name="priority" eval="16"/>
+            <field name='inherit_id' ref='register_accounting.view_cheque_register_tree' />
+            <field name="arch" type="xml">
+                <xpath expr="/tree/field[@name='name']" position="before">
+                    <field name="instance_id"/>
+                </xpath>
+            </field>
+        </record>
+        
+    </data>
+</openerp>

=== added file 'msf_instance/res_company.py'
--- msf_instance/res_company.py	1970-01-01 00:00:00 +0000
+++ msf_instance/res_company.py	2012-06-04 07:08:04 +0000
@@ -0,0 +1,79 @@
+#!/usr/bin/env python
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2012 TeMPO Consulting, MSF. All Rights Reserved
+#    Developer: Olivier DOSSMANN
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+from osv import osv, fields
+from tools.translate import _
+
+class res_company(osv.osv):
+    _name = 'res.company'
+    _inherit = 'res.company'
+
+    _columns = {
+        'instance_id': fields.many2one('msf.instance', string="Proprietary Instance", 
+            help="Representation of the current instance"),
+    }
+    
+    def write(self, cr, uid, ids, vals, context=None):
+        instance_obj = self.pool.get('msf.instance')
+        if 'instance_id' in vals:
+            # only one company (unicity)
+            if len(ids) != 1:
+                raise osv.except_osv(_('Error'), _("Only one company per instance!") or '')
+            company = self.browse(cr, uid, ids[0], context=context)
+            if not company.instance_id:
+                # An instance was not set; add DB name and activate it
+                instance_obj.write(cr, uid, [vals['instance_id']], {'instance': cr.dbname,
+                                                                    'state': 'active'}, context=context)
+            else:
+                # An instance was already set
+                old_instance_id = company.instance_id.id
+                # Deactivate the instance
+                instance_obj.write(cr, uid, [old_instance_id], {'state': 'inactive'}, context=context)
+                # add DB name and activate it
+                instance_obj.write(cr, uid, [vals['instance_id']], {'instance': cr.dbname,
+                                                                    'state': 'active'}, context=context)
+                # refresh journals 
+                analytic_journals_ids = self.pool.get('account.analytic.journal').search(cr,
+                                                                                         uid,
+                                                                                         [('instance_id', '=', old_instance_id)],
+                                                                                         context=context)
+                self.pool.get('account.analytic.journal').write(cr,
+                                                                uid,
+                                                                analytic_journals_ids,
+                                                                {'instance_id': vals['instance_id']},
+                                                                context=context)
+                
+                journals_ids = self.pool.get('account.journal').search(cr,
+                                                                       uid,
+                                                                       [('instance_id', '=', old_instance_id)],
+                                                                       context=context)
+                self.pool.get('account.journal').write(cr,
+                                                       uid,
+                                                       journals_ids,
+                                                       {'instance_id': vals['instance_id']},
+                                                       context=context)
+            
+        return super(res_company, self).write(cr, uid, ids, vals, context=context)
+                
+res_company()
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

